--------------------
-- Ace2 Libraries --
--------------------
local L = AceLibrary("AceLocale-2.2"):new("GearRating")
local T = AceLibrary("Tablet-2.0")


------------------
-- Ace2 options --
------------------
local options = { 
    type='group',
    args = {
        self = {
            type = 'group',
            name = L["Self to"],
            desc = L["Sends your own GR..."],
            order = 1,
            args = {
                self = {
                    type = 'execute',
                    name = L["Self"],
                    desc = L["...to yourself."],
                    func = function() GR_Handle("player", "SELF") end,
                    order = 1,
                },
                say = {
                    type = 'execute',
                    name = L["Say"],
                    desc = L["...to your surroundings, using /say (/s)."],
                    func = function() GR_Handle("player", "SAY") end,
                    order = 2,
                },
                target = {
                    type = 'execute',
                    name = L["Target"],
                    desc = L["...to your target, using /whisper (/w)."],
                    func = function() GR_Handle("player", "TARGET") end,
                    order = 3,
                },
                focus = {
                    type = 'execute',
                    name = L["Focus"],
                    desc = L["...to your focused unit, using /whisper (/w)."],
                    func = function() GR_Handle("player", "FOCUS") end,
                    order = 4,
                },
                party = {
                    type = 'execute',
                    name = L["Party"],
                    desc = L["...to the party channel (/p)."],
                    func = function() GR_Handle("player", "PARTY") end,
                    order = 5,
                },
                guild = {
                    type = 'execute',
                    name = L["Guild"],
                    desc = L["...to the guild channel (/g)."],
                    func = function() GR_Handle("player", "GUILD") end,
                    order = 6,
                },
                officer = {
                    type = 'execute',
                    name = L["Officer"],
                    desc = L["...to the officers channel (/o)."],
                    func = function() GR_Handle("player", "OFFICER") end,
                    order = 7,
                },
                raid = {
                    type = 'execute',
                    name = L["Raid"],
                    desc = L["...to the raid channel (/ra)."],
                    func = function() GR_Handle("player", "RAID") end,
                    order = 8,
                },
                battleground = {
                    type = 'execute',
                    name = L["Battleground"],
                    desc = L["...to the battleground channel (/bg)."],
                    func = function() GR_Handle("player", "BATTLEGROUND") end,
                    order = 9,
                },
                whisper = {
                    type = 'text',
                    name = L["Whisper"],
                    desc = L["...to a specified player, using /whisper (/w)."],
                    usage = L["<player name>"],
                    order = 10,
                    get = false,
                    set = function(v) GR_Handle("player", "WHISPER", v) end,
                },
                channel = {
                    type = 'text',
                    name = L["Channel"],
                    desc = L["...to a specified channel."],
                    usage = L["<channel name or number>"],
                    order = 11,
                    get = false,
                    set = function(v) GR_Handle("player", "CHANNEL", v) end,
                },
            },
        },
        target = {
            type = 'group',
            name = L["Target to"],
            desc = L["Sends the GR of your target..."],
            order = 2,
            args = {
                self = {
                    type = 'execute',
                    name = L["Self"],
                    desc = L["...to yourself."],
                    func = function() GR_Handle("target", "SELF") end,
                    order = 1,
                },
                say = {
                    type = 'execute',
                    name = L["Say"],
                    desc = L["...to your surroundings, using /say (/s)."],
                    func = function() GR_Handle("target", "SAY") end,
                    order = 2,
                },
                target = {
                    type = 'execute',
                    name = L["Target"],
                    desc = L["...to your target, using /whisper (/w)."],
                    func = function() GR_Handle("target", "TARGET") end,
                    order = 3,
                },
                focus = {
                    type = 'execute',
                    name = L["Focus"],
                    desc = L["...to your focused unit, using /whisper (/w)."],
                    func = function() GR_Handle("target", "FOCUS") end,
                    order = 4,
                },
                party = {
                    type = 'execute',
                    name = L["Party"],
                    desc = L["...to the party channel (/p)."],
                    func = function() GR_Handle("target", "PARTY") end,
                    order = 5,
                },
                guild = {
                    type = 'execute',
                    name = L["Guild"],
                    desc = L["...to the guild channel (/g)."],
                    func = function() GR_Handle("target", "GUILD") end,
                    order = 6,
                },
                officer = {
                    type = 'execute',
                    name = L["Officer"],
                    desc = L["...to the officers channel (/o)."],
                    func = function() GR_Handle("target", "OFFICER") end,
                    order = 7,
                },
                raid = {
                    type = 'execute',
                    name = L["Raid"],
                    desc = L["...to the raid channel (/ra)."],
                    func = function() GR_Handle("target", "RAID") end,
                    order = 8,
                },
                battleground = {
                    type = 'execute',
                    name = L["Battleground"],
                    desc = L["...to the battleground channel (/bg)."],
                    func = function() GR_Handle("target", "BATTLEGROUND") end,
                    order = 9,
                },
                whisper = {
                    type = 'text',
                    name = L["Whisper"],
                    desc = L["...to a specified player, using /whisper (/w)."],
                    usage = L["<player name>"],
                    order = 10,
                    get = false,
                    set = function(v) GR_Handle("target", "WHISPER", v) end,
                },
                channel = {
                    type = 'text',
                    name = L["Channel"],
                    desc = L["...to a specified channel."],
                    usage = L["<channel name or number>"],
                    order = 11,
                    get = false,
                    set = function(v) GR_Handle("target", "CHANNEL", v) end,
                },
            },
        },
        focus = {
            type = 'group',
            name = L["Focus to"],
            desc = L["Sends the GR of your focused unit..."],
            order = 3,
            args = {
                self = {
                    type = 'execute',
                    name = L["Self"],
                    desc = L["...to yourself."],
                    func = function() GR_Handle("focus", "SELF") end,
                    order = 1,
                },
                say = {
                    type = 'execute',
                    name = L["Say"],
                    desc = L["...to your surroundings, using /say (/s)."],
                    func = function() GR_Handle("focus", "SAY") end,
                    order = 2,
                },
                target = {
                    type = 'execute',
                    name = L["Target"],
                    desc = L["...to your target, using /whisper (/w)."],
                    func = function() GR_Handle("focus", "TARGET") end,
                    order = 3,
                },
                focus = {
                    type = 'execute',
                    name = L["Focus"],
                    desc = L["...to your focused unit, using /whisper (/w)."],
                    func = function() GR_Handle("focus", "FOCUS") end,
                    order = 4,
                },
                party = {
                    type = 'execute',
                    name = L["Party"],
                    desc = L["...to the party channel (/p)."],
                    func = function() GR_Handle("focus", "PARTY") end,
                    order = 5,
                },
                guild = {
                    type = 'execute',
                    name = L["Guild"],
                    desc = L["...to the guild channel (/g)."],
                    func = function() GR_Handle("focus", "GUILD") end,
                    order = 6,
                },
                officer = {
                    type = 'execute',
                    name = L["Officer"],
                    desc = L["...to the officers channel (/o)."],
                    func = function() GR_Handle("focus", "OFFICER") end,
                    order = 7,
                },
                raid = {
                    type = 'execute',
                    name = L["Raid"],
                    desc = L["...to the raid channel (/ra)."],
                    func = function() GR_Handle("focus", "RAID") end,
                    order = 8,
                },
                battleground = {
                    type = 'execute',
                    name = L["Battleground"],
                    desc = L["...to the battleground channel (/bg)."],
                    func = function() GR_Handle("focus", "BATTLEGROUND") end,
                    order = 9,
                },
                whisper = {
                    type = 'text',
                    name = L["Whisper"],
                    desc = L["...to a specified player, using /whisper (/w)."],
                    usage = L["<player name>"],
                    order = 10,
                    get = false,
                    set = function(v) GR_Handle("focus", "WHISPER", v) end,
                },
                channel = {
                    type = 'text',
                    name = L["Channel"],
                    desc = L["...to a specified channel."],
                    usage = L["<channel name or number>"],
                    order = 11,
                    get = false,
                    set = function(v) GR_Handle("focus", "CHANNEL", v) end,
                },
            },
        },
        party = {
            type = 'group',
            name = L["Party to"],
            desc = L["Sends the GRs of your party..."],
            order = 4,
            args = {
                self = {
                    type = 'execute',
                    name = L["Self"],
                    desc = L["...to yourself."],
                    func = function() GR_Handle("party", "SELF") end,
                    order = 1,
                },
                say = {
                    type = 'execute',
                    name = L["Say"],
                    desc = L["...to your surroundings, using /say (/s)."],
                    func = function() GR_Handle("party", "SAY") end,
                    order = 2,
                },
                target = {
                    type = 'execute',
                    name = L["Target"],
                    desc = L["...to your target, using /whisper (/w)."],
                    func = function() GR_Handle("party", "TARGET") end,
                    order = 3,
                },
                focus = {
                    type = 'execute',
                    name = L["Focus"],
                    desc = L["...to your focused unit, using /whisper (/w)."],
                    func = function() GR_Handle("party", "FOCUS") end,
                    order = 4,
                },
                party = {
                    type = 'execute',
                    name = L["Party"],
                    desc = L["...to the party channel (/p)."],
                    func = function() GR_Handle("party", "PARTY") end,
                    order = 5,
                },
                guild = {
                    type = 'execute',
                    name = L["Guild"],
                    desc = L["...to the guild channel (/g)."],
                    func = function() GR_Handle("party", "GUILD") end,
                    order = 6,
                },
                officer = {
                    type = 'execute',
                    name = L["Officer"],
                    desc = L["...to the officers channel (/o)."],
                    func = function() GR_Handle("party", "OFFICER") end,
                    order = 7,
                },
                raid = {
                    type = 'execute',
                    name = L["Raid"],
                    desc = L["...to the raid channel (/ra)."],
                    func = function() GR_Handle("party", "RAID") end,
                    order = 8,
                },
                battleground = {
                    type = 'execute',
                    name = L["Battleground"],
                    desc = L["...to the battleground channel (/bg)."],
                    func = function() GR_Handle("party", "BATTLEGROUND") end,
                    order = 9,
                },
                whisper = {
                    type = 'text',
                    name = L["Whisper"],
                    desc = L["...to a specified player, using /whisper (/w)."],
                    usage = L["<player name>"],
                    order = 10,
                    get = false,
                    set = function(v) GR_Handle("party", "WHISPER", v) end,
                },
                channel = {
                    type = 'text',
                    name = L["Channel"],
                    desc = L["...to a specified channel."],
                    usage = L["<channel name or number>"],
                    order = 11,
                    get = false,
                    set = function(v) GR_Handle("party", "CHANNEL", v) end,
                },
            },
        },
    },
}

----------------------
-- Ace2 inheritance -- 
----------------------
GearRating = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0", "AceDB-2.0", "FuBarPlugin-2.0"); 
GearRating:RegisterChatCommand(L["Slash-Commands"], options) 
GearRating:RegisterDB("GearRatingDB") 
GearRating:RegisterDefaults("profile", { } )
GearRating.hasIcon = true; 


-----------------
-- FuBar Stuff --
-----------------
GearRating.OnMenuRequest = options;

local GR_own, GR_target, GR_focus;

function GearRating:OnTooltipUpdate()
	local cat = T:AddCategory(
        'columns', 3,
        'child_text2R', 1,
        'child_text2G', 0.5,
        'child_text2B', 0,
        'child_text3R', 1,
        'child_text3G', 1,
        'child_text3B', 1,
        'child_justify2', "LEFT",
        'child_justify3', "RIGHT"
    )

    cat:AddLine()
    
    if GR_own then
        cat:AddLine(
            'text', "Own",
            'text2', UnitName("player"),
            'text3', ""..GR_own
        )
    end
    if GR_target then
        cat:AddLine(
            'text', "Target",
            'text2', UnitName("target"),
            'text3', ""..GR_target
        )
    end
    if GR_focus then
        cat:AddLine(
            'text', "Focus:",
            'text2', UnitName("focus"),
            'text3', ""..GR_focus
        )
    end
end

function GearRating:OnDataUpdate()
    GR_own = GR_GetGearRating("player", true);
    GR_target = GR_GetGearRating("target", true);
    GR_focus = GR_GetGearRating("focus", true);
    
--    if not T:IsAttached(MiniMap) then
        GearRating:UpdateDisplay();
--    end
end

-----------------
-- Ace2 Events --
-----------------

function GearRating:OnInitialize()
    -- Called when the addon is loaded
end

function GearRating:OnEnable()
    -- Called when the addon is enabled
    
	self:RegisterBucketEvent({"PLAYER_TARGET_CHANGED", "PLAYER_FOCUS_CHANGED"}, 0.2, "UpdateData")
	self:RegisterBucketEvent({"UNIT_INVENTORY_CHANGED"}, 3, "UpdateData")
end

function GearRating:OnDisable()
    -- Called when the addon is disabled
end
