-------------------------------
-- Error and Debug functions --
-------------------------------
GR_LASTERROR = "";

GR_ERROR_OUTOFRANGE = "GR_ERROR_OUTOFRANGE";
GR_ERROR_ISENEMY = "GR_ERROR_ISENEMY";
GR_ERROR_NOTAPLAYER = "GR_ERROR_NOTAPLAYER";
GR_ERROR_NOTEXIST = "GR_ERROR_NOTEXIST";

GR_ERROR_NOSUCHCHANNEL = "GR_ERROR_NOSUCHCHANNEL";

function GR_Error(error, msg, silent)
    if not silent then
        GearRating:Print(GR_Red..msg);
    end
    GR_LASTERROR = error;
end

function GR_Debug(msg)
    GearRating:Print(GR_Yellow..msg);
end

--------------------------
-- LongFormatting functions --
--------------------------

function GR_LongFormat(unitID, gr)
    return "GR of "..UnitName(unitID)..": "..gr.." "..GR_Bracketed();
end

function GR_ShortFormat(unitID, gr)
    return "  - "..UnitName(unitID)..": "..gr;
end

--------------------
-- Chat functions --
--------------------

function GR_SendToSelf(msg)
    GearRating:Print( msg );
end

function GR_SendToChannel(msg, chattype, channel)
    SendChatMessage( msg, chattype, nil, channel );
end

